## halibut 1.3

=== charset/CMakeLists.txt ===
# CMake-based build system.

# I don't want to have to edit the master list of source files in more
# than one place, so let's get CMake to use its built-in file and
# string handling abilities to read the list out of Makefile.am
# alongside it.

cmake_minimum_required(VERSION 3.0)
project(libcharset LANGUAGES C)

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/Makefile.am MAKEFILE_AM)
string(REPLACE "\\\n" " " MAKEFILE_AM ${MAKEFILE_AM})
string(REGEX MATCHALL "[^ \n]* = [^\n]*" MAKEFILE_AM_DEFS ${MAKEFILE_AM})

foreach(MAKEFILE_AM_DEF ${MAKEFILE_AM_DEFS})
  if(${MAKEFILE_AM_DEF} MATCHES "^([a-z][^ ]*)_SOURCES = (.*)")
    set(TARGET ${CMAKE_MATCH_1})
    string(REGEX MATCHALL "[^ ]*\\.c" SOURCES ${CMAKE_MATCH_2})
    if ("libcharset_a" STREQUAL ${TARGET})
      add_library(charset STATIC ${SOURCES}
        ${CMAKE_CURRENT_BINARY_DIR}/sbcsdat.h)
      target_include_directories(charset PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
    elseif(NOT LIBCHARSET_LIBRARY_ONLY)
      add_executable(${TARGET} ${SOURCES}
        ${CMAKE_CURRENT_BINARY_DIR}/sbcsdat.h)
      target_include_directories(${TARGET} PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
      target_link_libraries(${TARGET} charset)
    endif()
  endif()
endforeach()

add_custom_command(OUTPUT sbcsdat.c
  COMMAND perl ${CMAKE_CURRENT_SOURCE_DIR}/sbcsgen.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/sbcs.dat
  --source=${CMAKE_CURRENT_BINARY_DIR}/sbcsdat.c
  DEPENDS sbcsgen.pl sbcs.dat)
add_custom_command(OUTPUT sbcsdat.h
  COMMAND perl ${CMAKE_CURRENT_SOURCE_DIR}/sbcsgen.pl
  ${CMAKE_CURRENT_SOURCE_DIR}/sbcs.dat
  --header=${CMAKE_CURRENT_BINARY_DIR}/sbcsdat.h
  DEPENDS sbcsgen.pl sbcs.dat)

=== doc/CMakeLists.txt ===
# Halibut is used to build its own documentation. So we can only build
# the documentation if we're not cross-compiling.

if(CMAKE_CROSSCOMPILING)
  message(WARNING "Not building the Halibut documentation in a cross-compile")
else()

  include(GNUInstallDirs)

  set(HALIBUT $<TARGET_FILE:halibut>)

  set(manual_sources
    ${CMAKE_CURRENT_SOURCE_DIR}/blurb.but
    ${CMAKE_CURRENT_SOURCE_DIR}/intro.but
    ${CMAKE_CURRENT_SOURCE_DIR}/running.but
    ${CMAKE_CURRENT_SOURCE_DIR}/input.but
    ${CMAKE_CURRENT_SOURCE_DIR}/output.but
    ${CMAKE_CURRENT_SOURCE_DIR}/licence.but
    ${CMAKE_CURRENT_SOURCE_DIR}/manpage.but
    ${CMAKE_CURRENT_SOURCE_DIR}/index.but
    )

  # Do the manual build in a subdirectory, to avoid the install
  # command making a CMakeFiles directory in the output location.
  set(manual_dir ${CMAKE_CURRENT_BINARY_DIR}/manual)
  file(MAKE_DIRECTORY ${manual_dir})
  add_custom_target(manual ALL
    BYPRODUCTS
      ${manual_dir}/index.html
      ${manual_dir}/halibut.txt
      ${manual_dir}/halibut.info
      ${manual_dir}/halibut.ps
      ${manual_dir}/halibut.pdf
      ${manual_dir}/halibut.chm
    COMMAND
      ${HALIBUT}
      --html
      --text=halibut.txt
      --info=halibut.info
      --ps=halibut.ps
      --pdf=halibut.pdf
      --chm=halibut.chm
      ${manual_sources}
    WORKING_DIRECTORY ${manual_dir}
    DEPENDS halibut ${manual_sources})

  add_custom_target(manpage ALL
    BYPRODUCTS
      halibut.1
    COMMAND
      ${HALIBUT}
      --man=halibut.1
      ${CMAKE_CURRENT_SOURCE_DIR}/manpage.but
    DEPENDS halibut ${CMAKE_CURRENT_SOURCE_DIR}/manpage.but)

  install(DIRECTORY ${manual_dir}/
    DESTINATION ${CMAKE_INSTALL_DOCDIR}
    FILES_MATCHING PATTERN "*.html")

  install(DIRECTORY ${manual_dir}/
    DESTINATION ${CMAKE_INSTALL_INFODIR}
    FILES_MATCHING PATTERN "*.info*")

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/halibut.1
    DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

endif()

=== debian/changelog ===
halibut (1.3-5) unstable; urgency=medium

  * Reupload due to tag2upload webhook glitch.

 -- Colin Watson <cjwatson@debian.org>  Mon, 13 Oct 2025 12:17:09 +0100

halibut (1.3-4) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Don't mix host flags and build compiler (closes: #1117014).

 -- Colin Watson <cjwatson@debian.org>  Fri, 03 Oct 2025 10:56:11 +0100

halibut (1.3-3) unstable; urgency=medium

  * Apply X-Style: black.
  * Update CMake version spec to 3.7...3.28 (closes: #1112984).

 -- Colin Watson <cjwatson@debian.org>  Mon, 01 Sep 2025 01:12:53 +0100

halibut (1.3-2) unstable; urgency=medium

  * Drop dh-exec, no longer needed with debhelper v13.

 -- Colin Watson <cjwatson@debian.org>  Fri, 24 Dec 2021 23:51:50 +0000

halibut (1.3-1) unstable; urgency=medium

  * New upstream release.
    - Ignore leading whitespace in an input file (closes: #898923).
    - Cleanly exit 1 if errors are detected during the document input phase
      (closes: #898928).
  * Rework packaging somewhat to handle upstream's switch to CMake.

 -- Colin Watson <cjwatson@debian.org>  Sun, 31 Oct 2021 00:25:12 +0100

halibut (1.2-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Update watch file format version to 4.
  * Bump debhelper from old 12 to 13.

  [ Colin Watson ]
  * Build-Depends: Drop now-unnecessary versioned constraint on dpkg-dev.

 -- Colin Watson <cjwatson@debian.org>  Fri, 24 Sep 2021 22:10:33 +0100

halibut (1.2-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from deprecated 9 to 12.
  * Rely on pre-initialized dpkg-architecture variables.

 -- Colin Watson <cjwatson@debian.org>  Sat, 06 Feb 2021 17:36:31 +0000

halibut (1.2-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field

  [ Colin Watson ]
  * Use debhelper-compat instead of debian/compat.
  * Backport from upstream:
    - Fix build failure with gcc -fno-common (closes: #957328).

 -- Colin Watson <cjwatson@debian.org>  Fri, 17 Apr 2020 17:19:39 +0100

halibut (1.2-2) unstable; urgency=medium

  * Move VCS to salsa.debian.org.

 -- Colin Watson <cjwatson@debian.org>  Sat, 05 May 2018 14:08:27 +0100

=== debian/control ===
Source: halibut
Section: text
Priority: optional
Maintainer: Colin Watson <cjwatson@debian.org>
Standards-Version: 3.9.6
Build-Depends:
 cmake,
 debhelper-compat (= 13),
Homepage: https://www.chiark.greenend.org.uk/~sgtatham/halibut.html
Vcs-Git: https://salsa.debian.org/debian/halibut.git
Vcs-Browser: https://salsa.debian.org/debian/halibut
X-Style: black

Package: halibut
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Enhances:
 enscript,
 vim,
Description: yet another free document preparation system
 This is yet another text formatting system, intended primarily for writing
 software documentation. It accepts a single source format and outputs any
 or all of text, HTML, Windows Help, man pages, GNU info, PostScript, or
 PDF. It has comprehensive indexing and cross-referencing support, and
 generates hyperlinks within output documents wherever possible. It supports
 Unicode, with the ability to fall back to an alternative representation
 when Unicode output is not available.

=== debian/rules ===
#! /usr/bin/make -f
%:
	dh $@

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DEB_CPPFLAGS_MAINT_APPEND := -D_FILE_OFFSET_BITS=64

include /usr/share/dpkg/default.mk

# Ensure that Halibut's own documentation is built in a consistent locale
# and timezone to avoid reproducibility problems.
export LC_ALL := C.UTF-8
export TZ := UTC

cmakeflags := -DCMAKE_INSTALL_DOCDIR=share/doc/halibut/html

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
override_dh_auto_configure:
	dh_auto_configure -- $(cmakeflags)
else
# When cross-compiling, we need to do a native build as well and use the
# documentation built by that.  (In principle it should also be possible to
# tell the cross build to use the halibut executable built by the native
# build, but persuading the upstream build system to do it that way round is
# more awkward.)
override_dh_auto_configure:
	dh_auto_configure -- $(cmakeflags)
	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_configure --reload-all-buildenv-variables -- \
		$(cmakeflags)

override_dh_auto_build:
	dh_auto_build
	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_build

override_dh_auto_clean:
	dh_auto_clean
	dpkg-architecture -a$(DEB_BUILD_ARCH) -f -c dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	$(MAKE) -C obj-$(DEB_BUILD_GNU_TYPE)/doc install \
		DESTDIR=$(CURDIR)/debian/halibut
endif
